/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *  STM32 USART1 (PA9, PA10)
  ******************************************************************************
  */

#include "main.h"

#include "stm32f4xx_ll_gpio.h"
#include "stm32f4xx_ll_bus.h"
#include "stm32f4xx_ll_usart.h"

void SystemClock_Config(void);
/* USER CODE BEGIN PFP */
#define ESCAPE_NORM    "\033[0m"

#define ESCAPE_BLACK   "\033[30m"
#define ESCAPE_RED     "\033[31m"
#define ESCAPE_GREEN   "\033[32m"
#define ESCAPE_YELLOW  "\033[33m"
#define ESCAPE_BLUE    "\033[34m"
#define ESCAPE_MAGENTA "\033[35m"
#define ESCAPE_CYAN    "\033[36m"
#define ESCAPE_WHITE   "\033[37m"
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
int __io_putchar(int ch)
{
	while( LL_USART_IsActiveFlag_TXE(USART1) == 0);
	LL_USART_TransmitData8  (USART1,ch);
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
	volatile int i;
	LL_GPIO_InitTypeDef  GPIO_InitStruct;

	LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_GPIOG);

// Port A clock enabling
	LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_GPIOA);

	GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
	GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
	GPIO_InitStruct.Pin = LL_GPIO_PIN_13;
	LL_GPIO_Init  (GPIOG,&GPIO_InitStruct);

	GPIO_InitStruct.Pin = LL_GPIO_PIN_14;
	LL_GPIO_Init  (GPIOG,&GPIO_InitStruct);

// Port A PA9, AF7
	GPIO_InitStruct.Alternate = LL_GPIO_AF_7;
	GPIO_InitStruct.Mode	  =	LL_GPIO_MODE_ALTERNATE ;
	GPIO_InitStruct.Pin		  = LL_GPIO_PIN_9;
	LL_GPIO_Init  (GPIOA,&GPIO_InitStruct);

// Port A PA10, input AF7
	GPIO_InitStruct.Alternate = LL_GPIO_AF_7;
	GPIO_InitStruct.Mode	  =	LL_GPIO_MODE_ALTERNATE ;
	GPIO_InitStruct.Pin		  = LL_GPIO_PIN_10;
	LL_GPIO_Init  (GPIOA,&GPIO_InitStruct);

// USART1 Clock enable (APB2)
	LL_APB2_GRP1_EnableClock  (LL_APB2_GRP1_PERIPH_USART1);
// USART1 Init

	LL_USART_InitTypeDef  USART_InitStruct;
	LL_USART_StructInit(&USART_InitStruct);
	LL_USART_Init  (USART1,	&USART_InitStruct ) ;

//USART1 Asynchron mode
	LL_USART_ConfigAsyncMode  (USART1);
// USART1 Enable
	LL_USART_Enable  (USART1);

	LL_GPIO_TogglePin  (GPIOG, LL_GPIO_PIN_13);


	printf(ESCAPE_YELLOW __DATE__ " " __TIME__ "\r\n" ESCAPE_NORM);
  while (1)
  {
	for(i=0;i<1000000;i++);
	LL_GPIO_TogglePin  (GPIOG, LL_GPIO_PIN_13 | LL_GPIO_PIN_14);
	printf(ESCAPE_MAGENTA "Hello ARM Cortex \r\n" ESCAPE_NORM );

// USART1 Transmit


  }

}




/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
